kdeui Library: KXMLGUIClient Class Reference (kdeui Library)

| # kdeui Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KXMLGUIClient Class Reference

A KXMLGUIClient can be used with KXMLGUIFactory to create a GUI from actions and an XML document, and can be dynamically merged with other KXMLGUIClients. More...

`#include <kxmlguiclient.h>`

Inheritance diagram for KXMLGUIClient:

[legend]
Collaboration diagram for KXMLGUIClient:

[legend]
List of all members.

## Public Types
enum | ReverseStateChange { StateNoReverse, StateReverse }
## Public Member Functions
| KXMLGUIClient ()
| KXMLGUIClient (KXMLGUIClient *parent)
virtual | ~KXMLGUIClient ()
KAction * | action (const char *name) const
virtual KAction * | action (const QDomElement &element) const
virtual KActionCollection * | actionCollection () const
virtual KInstance * | instance () const
virtual QDomDocument | domDocument () const
virtual QString | xmlFile () const
virtual QString | localXMLFile () const
void | setXMLGUIBuildDocument (const QDomDocument &doc)
QDomDocument | xmlguiBuildDocument () const
void | setFactory (KXMLGUIFactory *factory)
KXMLGUIFactory * | factory () const
KXMLGUIClient * | parentClient () const
void | insertChildClient (KXMLGUIClient *child)
void | removeChildClient (KXMLGUIClient *child)
const QPtrList< KXMLGUIClient > * | childClients ()
void | setClientBuilder (KXMLGUIBuilder *builder)
KXMLGUIBuilder * | clientBuilder () const
void | reloadXML ()
void | plugActionList (const QString &name, const QPtrList< KAction > &actionList)
void | unplugActionList (const QString &name)
void | addStateActionEnabled (const QString &state, const QString &action)
void | addStateActionDisabled (const QString &state, const QString &action)
StateChange | getActionsToChangeForState (const QString &state)
void | beginXMLPlug (QWidget *)
void | endXMLPlug ()
void | prepareXMLUnplug (QWidget *)
## Static Public Member Functions
static QString | findMostRecentXMLFile (const QStringList &files, QString &doc)
## Protected Member Functions
virtual void | setInstance (KInstance *instance)
virtual void | setXMLFile (const QString &file, bool merge=false, bool setXMLDoc=true)
virtual void | setLocalXMLFile (const QString &file)
virtual void | setXML (const QString &document, bool merge=false)
virtual void | setDOMDocument (const QDomDocument &document, bool merge=false)
virtual void | conserveMemory ()
virtual void | stateChanged (const QString &newstate, ReverseStateChange reverse=StateNoReverse)
virtual void | virtual_hook (int id, void *data)
## Friends
class | KEditToolbarWidget

## Detailed Description

A KXMLGUIClient can be used with KXMLGUIFactory to create a GUI from actions and an XML document, and can be dynamically merged with other KXMLGUIClients.

Definition at line 43 of file kxmlguiclient.h.

## Constructor & Destructor Documentation

KXMLGUIClient::KXMLGUIClient | ( |  | ) |

| Constructs a KXMLGUIClient which can be used with a KXMLGUIFactory to create a GUI from actions and an XML document, and which can be dynamically merged with other KXMLGUIClients. Definition at line 67 of file kxmlguiclient.cpp.

KXMLGUIClient::KXMLGUIClient | ( | KXMLGUIClient * | parent | ) |

| Constructs a KXMLGUIClient which can be used with a KXMLGUIFactory to create a GUI from actions and an XML document, and which can be dynamically merged with other KXMLGUIClients. This constructor takes an additional `parent` argument, which makes the client a child client of the parent. Child clients are automatically added to the GUI if the parent is added. Definition at line 72 of file kxmlguiclient.cpp.

KXMLGUIClient::~KXMLGUIClient | ( |  | ) | `[virtual]`

| Destructs the KXMLGUIClient. Definition at line 78 of file kxmlguiclient.cpp.

## Member Function Documentation

KAction * KXMLGUIClient::action | ( | const char * | name | ) | const

| Retrieves an action of the client by name. If not found, it looks in its child clients. This method is provided for convenience, as it uses actionCollection() to get the action object. Definition at line 93 of file kxmlguiclient.cpp. References KActionCollection::action(), and actionCollection().

KAction * KXMLGUIClient::action | ( | const QDomElement & | element | ) | const`[virtual]`

| Retrieves an action for a given QDomElement. The default implementation uses the "name" attribute to query the action object via the other action() method. Definition at line 117 of file kxmlguiclient.cpp. References KActionCollection::action(), actionCollection(), and KGlobal::staticQString().

KActionCollection * KXMLGUIClient::actionCollection | ( |  | ) | const`[virtual]`

| Retrieves the entire action collection for the GUI client. If you subclass KXMLGUIClient you should call KActionCollection::setWidget( QWidget* ) with this object, or you will encounter subtle bugs with KAction keyboard shortcuts. This is not necessary if your KXMLGUIClient is a KMainWindow. See also: KActionCollection::setWidget( QWidget* ) Reimplemented in KEditToolbarWidget. Definition at line 107 of file kxmlguiclient.cpp. Referenced by action(), beginXMLPlug(), KXMLGUIFactory::configureShortcuts(), KMainWindow::configureToolbars(), KMainWindow::createGUI(), KMainWindow::createStandardStatusBarAction(), endXMLPlug(), KMainWindowInterface::KMainWindowInterface(), prepareXMLUnplug(), setDOMDocument(), setInstance(), KMainWindow::setupGUI(), setXMLFile(), and stateChanged().

KInstance * KXMLGUIClient::instance | ( |  | ) | const`[virtual]`

| Returns: The instance ( KInstance ) for this GUI client. Definition at line 123 of file kxmlguiclient.cpp. Referenced by KMainWindow::createGUI(), KMainWindow::helpMenu(), setClientBuilder(), setInstance(), and setXMLFile().

QDomDocument KXMLGUIClient::domDocument | ( |  | ) | const`[virtual]`

| Returns: The parsed XML in a QDomDocument, set by setXMLFile() or setXML(). This document describes the layout of the GUI. Definition at line 128 of file kxmlguiclient.cpp. Referenced by KMainWindow::createGUI().

QString KXMLGUIClient::xmlFile | ( |  | ) | const`[virtual]`

| This will return the name of the XML file as set by setXMLFile(). If setXML() is used directly, then this will return NULL. The filename that this returns is obvious for components as each component has exactly one XML file. In non-components, however, there are usually two: the global file and the local file. This function doesn't really care about that, though. It will always return the last XML file set. This, in almost all cases, will be the local XML file. Returns: The name of the XML file or QString::null Definition at line 133 of file kxmlguiclient.cpp. Referenced by KXMLGUIFactory::configureShortcuts(), KMainWindow::configureToolbars(), reloadXML(), KEditToolbarWidget::save(), and KMainWindow::saveNewToolbarConfig().

void KXMLGUIClient::setFactory | ( | KXMLGUIFactory * | factory | ) |

| This method is called by the KXMLGUIFactory as soon as the client is added to the KXMLGUIFactory's GUI. Definition at line 550 of file kxmlguiclient.cpp. References factory().

KXMLGUIFactory * KXMLGUIClient::factory | ( |  | ) | const

| Retrieves a pointer to the KXMLGUIFactory this client is associated with (will return 0L if the client's GUI has not been built by a KXMLGUIFactory. Definition at line 555 of file kxmlguiclient.cpp. Referenced by KEditToolbarWidget::save(), setFactory(), and KMainWindow::setStandardToolBarMenuEnabled().

KXMLGUIClient * KXMLGUIClient::parentClient | ( |  | ) | const

| KXMLGUIClients can form a simple child/parent object tree. This method returns a pointer to the parent client or 0L if it has no parent client assigned. Definition at line 560 of file kxmlguiclient.cpp.

void KXMLGUIClient::insertChildClient | ( | KXMLGUIClient * | child | ) |

| Use this method to make a client a child client of another client. Usually you don't need to call this method, as it is called automatically when using the second constructor, which takes a parent argument. Definition at line 565 of file kxmlguiclient.cpp. References d, and removeChildClient().

void KXMLGUIClient::removeChildClient | ( | KXMLGUIClient * | child | ) |

| Removes the given `child` from the client's children list. Definition at line 573 of file kxmlguiclient.cpp. References d. Referenced by insertChildClient().

const QPtrList< KXMLGUIClient > * KXMLGUIClient::childClients | ( |  | ) |

| Retrieves a list of all child clients. Definition at line 588 of file kxmlguiclient.cpp.

void KXMLGUIClient::setClientBuilder | ( | KXMLGUIBuilder * | builder | ) |

| A client can have an own KXMLGUIBuilder. Use this method to assign your builder instance to the client (so that the KXMLGUIFactory can use it when building the client's GUI) Client specific guibuilders are useful if you want to create custom container widgets for your GUI. Definition at line 593 of file kxmlguiclient.cpp. References instance().

KXMLGUIBuilder * KXMLGUIClient::clientBuilder | ( |  | ) | const

| Retrieves the client's GUI builder or 0L if no client specific builder has been assigned via setClientBuilder(). Definition at line 600 of file kxmlguiclient.cpp.

void KXMLGUIClient::reloadXML | ( |  | ) |

| Forces this client to re-read its XML resource file. This is intended to be used when you know that the resource file has changed and you will soon be rebuilding the GUI. It has no useful effect with non-KParts GUIs, so don't bother using it unless your app is component based. Definition at line 150 of file kxmlguiclient.cpp. References QString::isEmpty(), setXMLFile(), and xmlFile().

void KXMLGUIClient::plugActionList | ( | const QString & | name,
|  | const QPtrList< KAction > & | actionList
| ) |

| ActionLists are a way for XMLGUI to support dynamic lists of actions. E.g. if you are writing a file manager, and there is a menu file whose contents depend on the mimetype of the file that is selected, then you can achieve this using ActionLists. It works as follows: In your xxxui.rc file ( the one that you set in setXMLFile() ), you put an <ActionList name="xxx"> tag. E.g.
       * <kpartgui name="xxx_part" version="1">
       * <MenuBar>
       *   <Menu name="file">
       *     ...  <!-- some useful actions-->
       *     <ActionList name="xxx_file_actionlist" />
       *     ...  <!-- even more useful actions-->
       *   </Menu>
       *   ...
       * </MenuBar>
       * </kpartgui>
       *
This tag will get expanded to a list of actions. In the example above ( a file manager with a dynamic file menu ), you would call
     QPtrList<KAction> file_actions;
     for( ... )
       if( ... )
         file_actions.append( cool_action );
     unplugActionList( "xxx_file_actionlist" );
     plugActionList( "xxx_file_actionlist", file_actions );
every time a file is selected, unselected or ... Note: You should not call createGUI() after calling this function. In fact, that would remove the newly added actionlists again... Forgetting to call unplugActionList() before plugActionList() would leave the previous actions in the menu too.. Definition at line 605 of file kxmlguiclient.cpp.

void KXMLGUIClient::unplugActionList | ( | const QString & | name | ) |

| The complement of plugActionList() ... Definition at line 613 of file kxmlguiclient.cpp.

void KXMLGUIClient::beginXMLPlug | ( | QWidget * |  | ) |

| Since: 3.1 Definition at line 926 of file kxmlguiclient.cpp. References actionCollection(), and KActionCollection::beginXMLPlug().

void KXMLGUIClient::endXMLPlug | ( |  | ) |

| Since: 3.1 Definition at line 934 of file kxmlguiclient.cpp. References actionCollection(), and KActionCollection::endXMLPlug().

void KXMLGUIClient::prepareXMLUnplug | ( | QWidget * |  | ) |

| Since: 3.1 Definition at line 942 of file kxmlguiclient.cpp. References actionCollection(), and KActionCollection::prepareXMLUnplug().

void KXMLGUIClient::setInstance | ( | KInstance * | instance | ) | `[protected, virtual]`

| Sets the instance ( KInstance) for this part. Call this first in the inherited class constructor. (At least before setXMLFile().) Definition at line 157 of file kxmlguiclient.cpp. References actionCollection(), instance(), and KActionCollection::setInstance().

void KXMLGUIClient::setXMLFile | ( | const QString & | file,
|  | bool | merge = `false`,
|  | bool | setXMLDoc = `true`
| ) | `[protected, virtual]`

  | Sets the name of the rc file containing the XML for the part. Call this in the Part-inherited class constructor. Parameters:
  | file | Either an absolute path for the file, or simply the filename, which will then be assumed to be installed in the "data" resource, under a directory named like the instance.
  | merge | Whether to merge with the global document.
  | setXMLDoc | Specify whether to call setXML. Default is true. and the DOM document at once.
Definition at line 165 of file kxmlguiclient.cpp. References actionCollection(), KInstance::dirs(), endl(), KStandardDirs::findAllResources(), QString::fromLatin1(), instance(), QString::isEmpty(), kdWarning(), setXML(), and KActionCollection::setXMLFile(). Referenced by KMainWindow::createGUI(), reloadXML(), and KEditToolbarWidget::save().

void KXMLGUIClient::setXML | ( | const QString & | document,
|  | bool | merge = `false`
| ) | `[protected, virtual]`

| Sets the XML for the part. Call this in the Part-inherited class constructor if you don't call setXMLFile(). Definition at line 217 of file kxmlguiclient.cpp. References QDomDocument::setContent(), and setDOMDocument(). Referenced by setXMLFile().

void KXMLGUIClient::setDOMDocument | ( | const QDomDocument & | document,
|  | bool | merge = `false`
| ) | `[protected, virtual]`

| Sets the Document for the part, describing the layout of the GUI. Call this in the Part-inherited class constructor if you don't call setXMLFile or setXML . Definition at line 224 of file kxmlguiclient.cpp. References actionCollection(), and QDomDocument::documentElement(). Referenced by setXML().

void KXMLGUIClient::conserveMemory | ( |  | ) | `[protected, virtual]`

| This function will attempt to give up some memory after the GUI is built. It should never be used in apps where the GUI may be rebuilt at some later time (components, for instance). Definition at line 534 of file kxmlguiclient.cpp. Referenced by KMainWindow::createGUI().

void KXMLGUIClient::stateChanged | ( | const QString & | newstate,
|  | ReverseStateChange | reverse = `StateNoReverse`
| ) | `[protected, virtual]`

  | Actions can collectively be assigned a "State". To accomplish this the respective actions are tagged as <enable> or <disable> in a <State> </State> group of the XMLfile. During program execution the programmer can call stateChanged() to set actions to a defined state. Parameters:
  | newstate | Name of a State in the XMLfile.
  | reverse | If the flag reverse is set to StateReverse, the State is reversed. (actions to be enabled will be disabled and action to be disabled will be enabled) Default is reverse=false.
Definition at line 899 of file kxmlguiclient.cpp. References KActionCollection::action(), and actionCollection(). Referenced by KMainWindow::slotStateChanged().

The documentation for this class was generated from the following files:

- kxmlguiclient.h
- kxmlguiclient.cpp

This file is part of the documentation for kdeui Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:22:43 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003